"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-param-reassign, no-console */
var assert = require("assert");
var redux_1 = require("redux");
var _1 = require(".");
// Actions
var increment = _1.createAction('increment');
var decrement = _1.createAction('decrement');
var add = _1.createAction('add');
var override = _1.createAction('override');
var initialState = {
    counter: 0,
};
var reducer = _1.reduceReducers([
    _1.handleAction(increment, function (state) {
        state.counter += 1;
    }),
    _1.handleAction(decrement, function (state) {
        state.counter -= 1;
    }),
    _1.handleAction(add, function (state, _a) {
        var payload = _a.payload;
        state.counter += payload;
    }),
    _1.handleAction(override, function (_, _a) {
        var payload = _a.payload;
        return ({
            counter: payload,
        });
    }),
], initialState);
// Store
var store = redux_1.createStore(reducer);
store.subscribe(function () { return console.log('New state!', store.getState()); });
// Go to town!
store.dispatch(increment());
store.dispatch(increment());
store.dispatch(increment());
store.dispatch(decrement());
store.dispatch(add(10));
console.log('Final count!', store.getState().counter);
assert(store.getState().counter === 12);
//# sourceMappingURL=example.js.map